﻿
@{
    ViewData["Title"] = "لیست کاربرن";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}
@section scripts{
    <script src="~/ADMIN/JS/moment.js"></script>
    <script src="~/ADMIN/JS/moment-jalaali.js"></script>
}
<style>

    .k-button.k-button-icontext.k-grid-افزودننقش {
        color: #777;
        background-color: #fff;
        padding-left: 5px !important;
        padding-right: 5px !important;
        margin-top: 1px;
    }

    .k-button.k-button-icontext.k-grid-تعییررمزعبور {
        color: #777;
        background-color: #fff;
        padding-left: 5px !important;
        padding-right: 5px !important;
        margin-top: 1px;
    }

    label {
        font-size: 12px;
    }

    #grid table tr {
        font-weight: 400 !important;
    }

    .k-rtl .k-edit-form-container .k-edit-buttons {
        width: 114%;
    }

    #image-upload {
        margin-bottom: 10px;
    }
    #alertWindow{
        color: red;
        font-weight: 400;
    }
</style>
<div class="wrapper-grid">
    <div class="k-rtl">
        @(Html.Kendo().Grid<ApplicationUser>()
           .Name("grid")
           .Events(e => e.DataBound("DataBound"))
           .Events(e => e.Edit("Edit"))
           .Columns(columns =>
           {
               columns.Bound(c => c.PhoneNumber).Title("موبایل").HtmlAttributes(new { style = "font-size: 14px;font-weight: 400;letter-spacing: 1.6px;color: black;" });
               columns.Bound(c => c.PhoneNumberConfirmed).Title("تائید موبایل");
               columns.Bound(c => c.Register).Format("{0:yyyy-MM-dd HH:mm:ss}").HtmlAttributes(new { style = "white-space: pre-line;text-align:center;letter-spacing: 2px;font-size: 12px;" }).Title("تاریخ ثبت نام");
               columns.Bound(c => c.Register).Format("{0:yyyy-MM-dd HH:mm:ss}").HtmlAttributes(new { style = "white-space: pre-line;text-align:center;letter-spacing: 2px;font-size: 12px;" }).Title("آخرین ورود");
               columns.Bound(c => c.Email).Title("وضعیت کاربر");
               columns.Command(command =>
                       {
                   command.Edit().Text(" ");
                   command.Destroy().Text(" ");               
                   command.Custom("تعییر رمز عبور").Click("showPasswordChangeModal");
               }).Width(350);

           })
          .ToolBar(toolbar =>
          {
              toolbar.Create().Text("افزودن کاربر");
          })
          .Groupable()
          .ColumnMenu()

          .Editable(editable =>
          {
              editable.Mode(GridEditMode.PopUp).Window(q => q.Width(480));
              editable.DisplayDeleteConfirmation("آیا از حذف این ردیف اطمینان دارید ؟ ");
          }
          )
          .Pageable(pageable => pageable
               .Refresh(true)
               .PageSizes(true)
               .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
               .PageSizes(new int[] { 10, 20, 30 }))
          .Navigatable()
          .Selectable(selectable =>
          {
              selectable.Mode(GridSelectionMode.Single);
              selectable.Type(GridSelectionType.Row);
          })
          .Sortable(sortable =>
          {
              sortable.SortMode(GridSortMode.SingleColumn);
          })
          .Filterable()
          .Scrollable(s => s.Height("auto").Enabled(false))
          .DataSource(dataSource => dataSource
              .Ajax()
              .Sort(sort => sort.Add("Register").Descending())
              .Model(model => model.Id(p => p.Id))
              .Events(w => w.Error("error_handler"))
              .Read(read => read.Action("Users_Read", "Users"))
              .Create(create => create.Action("User_Create", "Users"))
              .Update(update => update.Action("User_Update", "Users"))
              .Destroy(destroy => destroy.Action("User_DestroyAsync", "Users"))
          )
        )
    </div>
</div>
  
@(Html.Kendo().Window().Name("passwordChange-Window")
  .Title("تغییر کلمه عبور")
  .Visible(false)
  .Modal(true)
  .Draggable(true)
  .Width(500).AutoFocus(true)
)

@(Html.Kendo().Window().Name("Confirm-Window")
  .Title("تغییر کلمه عبور")
  .Visible(false)
  .Modal(true)
  .Draggable(true)
  .Width(500)
)
@(Html.Kendo().Window()
    .Name("alertWindow")
    .Title("مدیریت خطا")
    .Draggable()
    .Resizable()
    .Width(400)
    .Height(100)
    .Modal(true)
    .Visible(false)
)
<form method="post"></form>

@* ################################  change password template ################################### *@
<script type="text/x-kendo-template" id="passwordChange-Wrapper">
    <div style="text-align:right; padding:0;  direction:rtl;">
        <p>
            <span style="font-weight:500; color:gray;display: inline-block;margin-bottom: 10px;display:block;">رمز عبور جدید را وارد نمائید</span>
            <input type="password"  id="Pass" style="width:100%; border:none; border-bottom:1px solid gray;"/>
            <input type="hidden" value="#=UserName#" />
            <button style="margin-top: 20px;display:block" class="btn" onclick="NewPassword(this)">تغییر کلمه عبور</button>
            <img src="/Images/Loader/ajax_loader.gif" style="display:none;vertical-align: middle;margin-top: 10px;margin-right: 10px;" />
        </p>

    </div>
</script>

<script type="text/x-kendo-template" id="Confirm-Wrapper">
    <div style="text-align:right; padding:0;  direction:rtl;">
        <span style="font-weight:500;color: green;">
            <i class="material-icons" style="color:green;vertical-align:middle;margin-top:-1px;">
                sentiment_satisfied_alt
            </i>
           کلمه عبور با موفقیت تغییر یافت .
        </span>
    </div>
</script>


<script>
  
    var passwordChange_Template = kendo.template($("#passwordChange-Wrapper").html());  
    var Confirm_Template = kendo.template($("#Confirm-Wrapper").html());

    function UserAvatarUpload(e) {
        var imagePath = e.response.Avatar;
        $("#Avatar").val(imagePath).trigger("change");
    }
    function RemoveUserAvatar(e) {

    }
    function DataBound(e) {
        var grid = this;
        grid.tbody.find("tr[role='row']").each(function (index, value) {
            var model = grid.dataItem(this);

            if (model.PhoneNumberConfirmed) $(this).find("td:nth-child(2)").html('<i title="تائید شماره موبایل" style= "color:green;vertical-align:middle;" class="material-icons">check_circle</i>')
            else $(this).find("td:nth-child(2)").html('<i title="عدم تائید شماره موبایل" style= "color:red;vertical-align:middle;" class="material-icons">cancel</i>')

            $(this).find('td').each(function (index, value) {
                if ($(this).text().includes(":") && $(this).text().includes("-")) {
                    var result = moment($(this).text(), 'YYYY-M-D HH:mm:ss')
                        .format('jYYYY/jM/jDD HH:mm:ss')
                    result = result.replace(' ', '\n');
                    $(this).text(result)
                }
            })

        });

    }
    function showAlertWindow(message) {
        var alertWindow = $('#alertWindow').data('kendoWindow');
        alertWindow.content(message);
        alertWindow.refresh();
        alertWindow.center();
        alertWindow.open();
     }
    function error_handler(e) {
    if (e.errors) {
        var message = "خطاهای رخ داده :\n";
        $.each(e.errors, function (key, value) {
            if ('errors' in value) {
                $.each(value.errors, function () {
                    message += this + "\n";
                });
            }
        });
        showAlertWindow(message);
    }
}
    function Edit(e) {



        var kendoWindow = e.container.data("kendoWindow");
        if (e.model.isNew()) {

            $(e.container["0"].firstChild.children[0]).hide();
            $(e.container["0"].firstChild.children[1]).hide();
            $(e.container["0"].firstChild.children[4]).hide();
            $(e.container["0"].firstChild.children[5]).hide();
            //$(e.container["0"].firstChild.children[6]).hide();
            //$(e.container["0"].firstChild.children[7]).hide();
            $(e.container["0"].firstChild.children[8]).hide();
            $(e.container["0"].firstChild.children[9]).hide();
            $(e.container["0"].firstChild.children[10]).hide();
            $(e.container["0"].firstChild.children[11]).hide();
            $(e.container["0"].firstChild.children[14]).hide();
            $(e.container["0"].firstChild.children[15]).hide();
            $(e.container["0"].firstChild.children[16]).hide();
            $(e.container["0"].firstChild.children[17]).hide();
            $(e.container["0"].firstChild.children[18]).hide();
            $(e.container["0"].firstChild.children[19]).hide();
            $(e.container["0"].firstChild.children[20]).hide();
            $(e.container["0"].firstChild.children[21]).hide();
            $(e.container["0"].firstChild.children[22]).hide();
            $(e.container["0"].firstChild.children[23]).hide();
            $(e.container["0"].firstChild.children[24]).hide();
            $(e.container["0"].firstChild.children[25]).hide();
            $(e.container["0"].firstChild.children[26]).hide();
            $(e.container["0"].firstChild.children[27]).hide();
            $(e.container["0"].firstChild.children[28]).hide();
            $(e.container["0"].firstChild.children[29]).hide();
            //$(e.container["0"].firstChild.children[30]).hide();
            //$(e.container["0"].firstChild.children[31]).hide();
            //$(e.container["0"].firstChild.children[32]).hide();
            //$(e.container["0"].firstChild.children[33]).hide();
            //$(e.container["0"].firstChild.children[34]).hide();
            //$(e.container["0"].firstChild.children[35]).hide();
            $(e.container["0"].firstChild.children[36]).hide();
            $(e.container["0"].firstChild.children[37]).hide();
            $(e.container["0"].firstChild.children[38]).hide();
            $(e.container["0"].firstChild.children[39]).hide();
            $(e.container["0"].firstChild.children[40]).hide();
            $(e.container["0"].firstChild.children[41]).hide();
            //$(e.container["0"].firstChild.children[42]).hide();
            //$(e.container["0"].firstChild.children[43]).hide();
            $(e.container["0"].firstChild.children[44]).hide();
            $(e.container["0"].firstChild.children[45]).hide();
            $(e.container["0"].firstChild.children[46]).hide();
            $(e.container["0"].firstChild.children[47]).hide();
            $(e.container["0"].firstChild.children[48]).hide();
            $(e.container["0"].firstChild.children[49]).hide();

            kendoWindow.setOptions({
                title: "افزودن کاربر"
            });
        } else {

            //$(e.container["0"].firstChild.children[0]).hide();
            //$(e.container["0"].firstChild.children[1]).hide();
            //$(e.container["0"].firstChild.children[36]).hide();
            //$(e.container["0"].firstChild.children[37]).hide();
            //$(e.container["0"].firstChild.children[38]).hide();
            //$(e.container["0"].firstChild.children[39]).hide();
            //$(e.container["0"].firstChild.children[40]).hide();
            //$(e.container["0"].firstChild.children[41]).hide();
            //$(e.container["0"].firstChild.children[42]).hide();
            //$(e.container["0"].firstChild.children[43]).hide();



            kendoWindow.setOptions({
                title: "ویرایش کاربر"
            });
        }
    }   
    function showConfirmModal() {
        var wnd = $("#Confirm-Window").data("kendoWindow");
        wnd.content(Confirm_Template);
        wnd.center().open();
    }
    function NewPassword(ele) {

              $(ele).next().show();
              $.ajax({
                  url: '/Admin/Users/PasswordChange',
                  headers:
                  {
                      "RequestVerificationToken": $('input:hidden[name="__RequestVerificationToken"]').val()
                  },
                  type: 'POST',
                  dataType: 'json',
                  data: {
                      Id: $(ele).prev().val(),
                      Password: $(ele).prev().prev().val()
                  },
                  success: function (res) {

                      $(ele).next().hide();

                       var wnd = $("#passwordChange-Window").data("kendoWindow");
                       wnd.close();
             
                      if (res) {                         
                          showConfirmModal();
                      }
                      else {                       
                          alert("تغییر کلمه عبور ناموفق !!!")
                      }
             
                  }
              });

    }

    function showPasswordChangeModal(e) {

        e.preventDefault();
        var dataItem = this.dataItem($(e.currentTarget).closest("tr"));
        var wnd = $("#passwordChange-Window").data("kendoWindow");
        wnd.content(passwordChange_Template(dataItem));
        wnd.center().open();

    }
    function Error(e) {
        if (e.errors) {
            var message = "خطای رخ داده:\n";
            $.each(e.errors, function (key, value) {
                if ('errors' in value) {
                    $.each(value.errors, function () {
                        message += this + "\n";
                    });
                }
            });
            alert(message);
        }
    }

</script>

